import controlP5.*;

ControlP5 controlP5;
PerlinField perlinField;
ArrayList sprites;

public float falloff = .5;
public int octaves = 5;
public float noiseScaleX = 0.05;
public float noiseScaleY = 0.05;
public float accelerationX;
public float accelerationY;
public int spritesWanted = 10;


PVector gravity;
PVector wind;

void setup() {
	size(564, 564);

	background(0);
	smooth();

	gravity = new PVector(0, 0.01);
	wind = new PVector(0, 0);	

	perlinField = new PerlinField(width, height, this);

  controlP5 = new ControlP5(this);
  Slider spritesWantedlider = controlP5.addSlider("spritesWanted", 0, 100, spritesWanted, 300, height - 80, 130, 10);
  Slider falloffSlider = controlP5.addSlider("falloff", 0, 2, falloff, 300, height - 65, 130, 10);
  Slider octavesSlider = controlP5.addSlider("octaves", 0, 20, octaves, 300, height - 50, 130, 10);
  Slider noiseScaleXSlider = controlP5.addSlider("noiseScaleX", 0, .1, noiseScaleX, 300, height - 35, 130, 10);	
  Slider noiseScaleYSlider = controlP5.addSlider("noiseScaleY", 0, .1, noiseScaleY, 300, height - 20, 130, 10);	
  Slider accelerationXSlider = controlP5.addSlider("accelerationX", -.1, .1, 0, 100, height - 35, 130, 10);	
  Slider accelerationYSlider = controlP5.addSlider("accelerationY", -.1, .1, 0, 100, height - 20, 130, 10);

	sprites = new ArrayList();
}


void draw() {
  background(0);

  // Maintain the sprite population.
  while (sprites.size() < spritesWanted) {
    sprites.add(new Sprite());
  }

	// update perlin field settings from the sliders
	perlinField.falloff = falloff;
	perlinField.octaves = octaves;	
	perlinField.acceleration.x = accelerationX;
	perlinField.acceleration.y = accelerationY;
	perlinField.scale.x = noiseScaleX;
	perlinField.scale.y = noiseScaleY;

	perlinField.tick();
	
	// use perlin as frictoin	
  for (int i = sprites.size() - 1; i >= 0; i--) {
	    Sprite sprite = (Sprite) sprites.get(i);
			sprite.tick();
			

			
	    // Clean up the dead.
	    if(sprite.killMe) {
	      sprites.remove(i);
	    }			
	}
		


}










